/*
 * linescanCamera.h
 *
 *  Created on: 27 Jan 2025
 *      Author: user
 */

#ifndef LINESCANCAMERA_H_
#define LINESCANCAMERA_H_

#include <stdint.h>
#include "fsl_adc16.h"
#include "fsl_ftm.h"
#include "fsl_gpio.h"

// Define constants
#define IMAGE_SIZE 128
#define THRESHOLD 20
#define SI_CYCLE_LIMIT 200

// Global variables (extern to be defined in the source file)
extern uint16_t ImageData[IMAGE_SIZE];
extern volatile uint16_t currentPixelNumber;
extern int ImageDataDifference[IMAGE_SIZE];
extern int CompareValue;
extern int BlackLineLeft;
extern int BlackLineRight;
extern int RoadMiddle;
extern int Deviation;

// Function prototypes
void calculateDeviation(void);
void findBlackLineRight(void);
void findBlackLineLeft(void);
void ADC1_IRQHANDLER(void);
void FTM1_IRQHANDLER(void);

#endif // LINESCANCAMERA_H_
